"use strict";

require("core-js/modules/es.array.concat");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.assign");

require("core-js/modules/es.regexp.exec");

require("core-js/modules/es.string.replace");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _global = require("global");

var _react = _interopRequireDefault(require("react"));

var _api = require("@storybook/api");

var _preview = require("../components/preview/preview");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var nonAlphanumSpace = /[^a-z0-9 ]/gi;
var doubleSpace = /\s\s/gi;

var replacer = function replacer(match) {
  return " ".concat(match, " ");
};

var addExtraWhiteSpace = function addExtraWhiteSpace(input) {
  return input.replace(nonAlphanumSpace, replacer).replace(doubleSpace, ' ');
};

var getDescription = function getDescription(storiesHash, storyId) {
  var storyInfo = storiesHash[storyId];

  if (storyInfo) {
    // @ts-ignore
    var kind = storyInfo.kind,
        name = storyInfo.name;
    return kind && name ? addExtraWhiteSpace("".concat(kind, " - ").concat(name)) : '';
  }

  return '';
};

var mapper = function mapper(_ref) {
  var api = _ref.api,
      state = _ref.state;
  var layout = state.layout,
      location = state.location,
      customQueryParams = state.customQueryParams,
      storiesHash = state.storiesHash,
      storyId = state.storyId;

  var _ref2 = storiesHash[storyId] || {},
      parameters = _ref2.parameters;

  return Object.assign({
    api: api,
    options: layout,
    description: getDescription(storiesHash, storyId)
  }, api.getUrlState(), {
    queryParams: customQueryParams,
    docsOnly: parameters && parameters.docsOnly,
    location: location,
    parameters: parameters
  });
};

function getBaseUrl() {
  try {
    return _global.PREVIEW_URL || 'iframe.html';
  } catch (e) {
    return 'iframe.html';
  }
}

var PreviewConnected = _react["default"].memo(function (props) {
  return _react["default"].createElement(_api.Consumer, {
    filter: mapper
  }, function (fromState) {
    var p = Object.assign({}, props, {
      baseUrl: getBaseUrl()
    }, fromState);
    return _react["default"].createElement(_preview.Preview, p);
  });
});

PreviewConnected.displayName = 'PreviewConnected';
var _default = PreviewConnected;
exports["default"] = _default;